#include "qgames.h"
#include <conio.h>
#include <stdio.h>
#include <stdlib.h>
#include <mem.h>
#include <math.h>
#include <alloc.h>

typedef struct _MATRIX
{
	float _00,_01,_02,_03;
	float _10,_11,_12,_13;
	float _20,_21,_22,_23;
	float _30,_31,_32,_33;
}MATRIX, *PMATRIX;

float* SinBuff;
float* CosBuff;
extern PSTR libVirScreen;

void InitMatrix(PMATRIX);
void InitSinCos(void);
void VgaScaleBitmap(PRECT,PBITMAP);

#define SIN(x) SinBuff[x & 0x1FF]
#define COS(x) CosBuff[x & 0x1FF]
#define SINBUFFLEN (511 * sizeof(float))
#define COSBUFFLEN (511 * sizeof(float))

void main()
{
	RECT rect = { 1,1,70,70};
	PSTR pBuffer;
	STMOUSEMAP stMap;
	BITMAP bmp;
	BMPOUTINFO bmpOut;
	RGBPAL rgbPal[256];

	if(LoadBMPPal("1.bmp",rgbPal) != QG_OK)
	{
		printf("  \n");
		return;
	}

	if(LoadBMPInfo("1.bmp",&bmp) != QG_OK)
		return;

	bmp.Buffer = malloc(bmp.Width * bmp.Height);

	if(bmp.Buffer == NULL)
	{
		printf("墠⠥ \n");
		return;
	}

	pBuffer = malloc(64000);

	if(pBuffer == NULL)
	{
		printf("墠⠥ \n");
		free(bmp.Buffer);
		return;
	}

	if(LoadBMPData("1.bmp",&bmp) != QG_OK)
	{
		free(bmp.Buffer);
		return;
	}

	bmpOut.PosX = 0;
	bmpOut.PosY = 0;

	SetDisplayMode(VGA_MODE);
	SetDisplayPal(rgbPal);
	SetVirScreen(pBuffer);
	while(!kbhit())
	{
		ClearScreen(10);
		VgaScaleBitmap(&rect,&bmp);
		CopyVirToScr_WDV();
		GetMouseMap(&stMap);
		rect.Right = stMap.PosX;
		rect.Bottom = stMap.PosY;
	}
	if(!getch())
		getch();
	SetDisplayMode(TEXT_MODE);
	free(bmp.Buffer);
}

void InitMatrix(PMATRIX pMatrix)
{
	memset(pMatrix,0,sizeof(PMATRIX));
	pMatrix->_00 = pMatrix->_11 = pMatrix->_22 = pMatrix->_33 = 1;
}

void InitSinCos(void)
{
	WORD Counter;

	for(Counter = 0;Counter < 511;Counter++)
	{
		SinBuff[Counter] = sin((float)(Counter) * 3.14 / 180);
		CosBuff[Counter] = cos((float)(Counter) * 3.14 / 180);
	}
}

void VgaScaleBitmap(PRECT pRect,PBITMAP pBmp)
{
	WORD K_X,K_Y;
	WORD CounterY,CounterX;
	WORD X_Param = 0,
		Y_Param = 0,
		X1_Param = 0,
		Y1_Param = 0;

	if(!(pRect->Right - pRect->Left))
		return;
	if(!(pRect->Bottom - pRect->Top))
		return;

	K_X = (pBmp->Width << 6 ) / (pRect->Right - pRect->Left);
	K_Y = (pBmp->Height << 6 ) / (pRect->Bottom - pRect->Top);


	for(CounterY = pRect->Top;CounterY < pRect->Bottom;CounterY++)
	{
		X1_Param = 0;
		X_Param = 0;
		Y_Param += K_Y;
		Y1_Param = Y_Param >> 6;
		for(CounterX = pRect->Left;CounterX < pRect->Right;CounterX++)
		{
			X_Param += K_X;
			X1_Param = X_Param >> 6;

			if(CounterX > 320 || CounterY > 200)
				break;

			if(X1_Param >= pBmp->Width)
				break;
			if(Y1_Param >= pBmp->Height)
				return;

			libVirScreen[CounterX + (CounterY * 320)] =
				pBmp->Buffer[X1_Param + (Y1_Param * pBmp->Width)];
		}
	}


}