/*
Qgames v2.0
() 1998 - 2001 ਫ ਩ ॢ
*/

#ifndef __QGAMES_H
#define __QGAMES_H

#ifndef __LARGE__
#error It's a library only for LARGE memory model!!!
#endif

#include <dos.h>
#include <io.h>


/* ⨯*/
typedef unsigned char BYTE;
typedef unsigned short WORD;
typedef unsigned long DWORD;
typedef unsigned int UINT;

typedef BYTE* PBYTE;
typedef WORD* PWORD;
typedef DWORD* PDWORD;

typedef unsigned char BOOL;
typedef char* PBOOL;

typedef char far* PSTR;
typedef const char far* PCSTR;

/*...*/
#define TRUE 1
#define FALSE 0

#define LOBYTE(w)           ((BYTE)(w))
#define HIBYTE(w)           ((BYTE)((UINT)(w) >> 8))

#define LOWORD(l)           ((WORD)(l))
#define HIWORD(l)           ((WORD)((DWORD)(l) >> 16))


#define BOUT(x,y);\
{             \
asm mov dx,x;\
asm mov al,y;\
asm out dx,al;\
}
#define BIN(x,y);\
{            \
asm mov dx,x;\
asm in al,dx;\
asm mov y,al;\
}

/*訡 QGAMES*/
#define QG_OK 0
#define QG_NOFILE 1
#define QG_ERFORMAT 2
#define QG_NOSUPPORT 3
#define QG_ERREAD 4
#define QG_ERWRITE 5


/*뢮*/

/*⠭ ० 뢮*/
typedef struct _RGBPAL
{
	BYTE Red;
	BYTE Green;
	BYTE Blue;
}RGBPAL,* PRGBPAL;

#define TEXT_MODE 0
#define VGA_MODE 1

void cdecl SetDisplayMode(BYTE);
void cdecl SetDisplayPal(PRGBPAL);
void cdecl WaitDisplayVrt(void);
BOOL cdecl GetDisplayVrt(void);

/* VGA*/
void cdecl ClearScreen(BYTE);
void cdecl SetVirScreen(PSTR);
void cdecl CopyVirToScr_WDV(void);
void cdecl CopyVirToScr(void);
/*뢮 ࠩ⮢...*/

typedef struct _RECT
{
	WORD Left;
	WORD Top;
	WORD Right;
	WORD Bottom;
}RECT,* PRECT;

typedef struct _BMPOUTINFO
{
	int PosX,PosY;
}BMPOUTINFO,*PBMPOUTINFO;

typedef struct _BITMAP
{
	WORD Width,Height;
	PSTR Buffer;
}BITMAP,* PBITMAP;

void cdecl VgaBitmap(PBITMAP,PBMPOUTINFO);
void cdecl VgaC_Bitmap(PBITMAP,PBMPOUTINFO);
void cdecl VgaBitmapBounds(PBITMAP,PBMPOUTINFO);
void cdecl VgaC_BitmapBounds(PBITMAP,PBMPOUTINFO);

void cdecl MonoBitmap(PBITMAP,PBMPOUTINFO,BYTE);
void cdecl MonoBitmapOr(PBITMAP,PBMPOUTINFO,BYTE);
void cdecl MonoBitmapXor(PBITMAP,PBMPOUTINFO,BYTE);
void cdecl MonoBitmapAnd(PBITMAP,PBMPOUTINFO,BYTE);

/*⮢ ०*/
#define TLV_LINE 0xB3
#define TLV_DOUBLELINE 0xBA
#define TLV_LOWBRIGHTBOX 0xB2
#define TLV_BRIGHTBOX 0xB1
#define TLV_HIGHBRIGHTBOX 0xB0
#define TLV_BOX 0xDB
#define TLH_LINE 0xC4
#define TLH_DOUBLELINE 0xC5
#define TLH_LOWBRIGHTBOX 0xB2
#define TLH_BRIGHTBOX 0xB1
#define TLH_HIGHBRIGHTBOX 0xB0
#define TLH_BOX 0xDB

void cdecl TxtCls(BYTE);
void cdecl TxtBox(BYTE,BYTE,BYTE,BYTE,BYTE);
void cdecl TxtVLine(BYTE,BYTE,BYTE,BYTE,BYTE);
void cdecl TxtHLine(BYTE,BYTE,BYTE,BYTE,BYTE);
void cdecl TxtOut(BYTE,BYTE,BYTE,PSTR);
void cdecl TxtBufferOut(BYTE,BYTE,BYTE,PSTR,BYTE);
void cdecl TxtStrOut(BYTE,BYTE,BYTE,PSTR,BYTE);
void cdecl TxtSymb(BYTE,BYTE,BYTE,BYTE);
		/**/

/*...*/
#define PRESS_KEY 1
#define RELEASE_KEY 2
#define UNKNOWN_KEY 0

#define TAB 9
#define CTRL 0x9d
#define ALT 0xb8
#define SHIFT 0xb6
#define PRNTSCR 0xe0
#define LEFT 0xac
#define UP 0xad
#define RIGHT 0xae
#define DOWN 0xaf
#define ENTER 0xd
#define ESC 0x1b
#define SPACE 0x20
#define END 0xcf
#define HOME 0xc7
#define PGUP 0xc9
#define PGDOWN 0xd1
#define INSERT 0xd2
#define DEL 0xd3
#define DELETE 0x7f
#define F1 0xbb
#define F2 0xbc
#define F3 0xbd
#define F4 0xbe
#define F5 0xbf
#define F6 0xc0
#define F7 0xc1
#define F8 0xc2
#define F9 0xc3
#define F10 0xc4

typedef struct _STKEYMAP
{
	BOOL Up,Down;
	BOOL Left,Right;
	BOOL Enter,Space;
	BOOL Tab,Ctrl,Alt,Shift;
	BOOL Esc,_F1;
}STKEYMAP,* PSTKEYMAP;


void cdecl QGamesKeyboard();
void cdecl DosKeyboard();

void cdecl GetMapKey(PSTKEYMAP);
BYTE cdecl GetKey(PBYTE);

/*...*/
typedef struct _STMOUSEMAP
{
	WORD PosX,PosY;
	BOOL RightKey,LeftKey;
}STMOUSEMAP,* PSTMOUSEMAP;

void cdecl MouseCursorOn();
void cdecl MouseCursorOff();
void cdecl SetMouseCursor(WORD,WORD,PBYTE);

BOOL cdecl GetMouseInit();
void cdecl GetMouseMap(PSTMOUSEMAP);
void cdecl GetMouseMoving(int* ,int*);

	/*  */
/*...*/

void cdecl QGamesTimer();
void cdecl DosTimer();

WORD cdecl GetTimerCounter();
void cdecl SetTimerFunc();

/*몠 SoundBlaster'a...*/
BOOL cdecl GetSBlaster(WORD);
void cdecl InitSBlaster(WORD);
void cdecl ResetSBlaster(WORD);
void cdecl SB_NoteOff(WORD,BYTE);
void cdecl SB_NoteOn(WORD,BYTE,BYTE,WORD);
void cdecl SB_AllNoteOff(WORD);
void cdecl SB_SetVolume(WORD,BYTE,BYTE);
void cdecl SB_SetVoice(WORD,BYTE,BYTE);
void cdecl SB_SetAD(WORD,BYTE,BYTE,BYTE);
void cdecl SB_SetSR(WORD,BYTE,BYTE,BYTE);

	/*  ࠧ묨 ଠ⠬ 䠩*/

/*Windows bitmapinfo*/
typedef struct _BITMAPFILEHEADER
{
	 WORD    bfType;
	 DWORD   bfSize;
	 WORD    bfReserved1;
	 WORD    bfReserved2;
	 DWORD   bfOffBits;
} BITMAPFILEHEADER,*PBITMAPFILEHEADER;


typedef struct _BITMAPINFOHEADER
{
	 DWORD   biSize;
	 DWORD   biWidth;
	 DWORD   biHeight;
	 WORD    biPlanes;
	 WORD    biBitCount;
	 DWORD   biCompression;
	 DWORD   biSizeImage;
	 DWORD   biXPelsPerMeter;
	 DWORD   biYPelsPerMeter;
	 DWORD   biClrUsed;
	 DWORD   biClrImportant;
} BITMAPINFOHEADER,*PBITMAPINFOHEADER;



typedef struct _RGBQUAD
{
	 BYTE    rgbBlue;
	 BYTE    rgbGreen;
	 BYTE    rgbRed;
	 BYTE    rgbReserved;
} RGBQUAD,*PRGBQUAD;

BYTE cdecl LoadBMPPal(PSTR,PRGBPAL);
BYTE cdecl LoadBMPInfo(PSTR,PBITMAP);
BYTE cdecl LoadBMPData(PSTR,PBITMAP);

/*Graphics interchange format*/
/*...*/
/*Wave format*/
/*...*/

   /*  Com - ⮬  */

/*Com - ...*/
#define COM1 0
#define COM2 1
#define COM3 2
#define COM4 3

#define ICS_1200 96
#define ICS_2400 48
#define ICS_4800 24
#define ICS_9600 12
#define ICS_19200 6
#define ICS_38400 3
#define ICS_57600 2
#define ICS_115200 1

#define ECP_WAIT 0
#define ECP_OK 1
#define ECP_READ 2
#define ECP_ERRORWR 3


BOOL cdecl InitStdCom(BYTE,WORD,BYTE);
void cdecl UninitStdCom(BYTE);
BYTE cdecl InStdCom(BYTE,PBYTE);
BYTE cdecl OutStdCom(BYTE,PBYTE);
BYTE cdecl GetStdComRWStat(BYTE);
BYTE cdecl GetStdComCTStat(BYTE);
BYTE cdecl GetStdComMDStat(BYTE);

typedef void(far* FNCOM)(BYTE);

#define FCM_NOBUFFER 1
#define FCM_ERRORLINE 2
#define FCM_DATASENDED 3
#define FCM_DATAREADED 4
#define FCM_MODEMLINE 5

void cdecl QGamesComPort(BYTE,WORD,BYTE);
void cdecl DosComPort();

void cdecl ISetComWBuff(PSTR,WORD);
void cdecl ISetComRBuff(PSTR,WORD);
void cdecl SetComFunc(FNCOM);
void cdecl IDefaultComFunc(BYTE);
void cdecl ContinueComPort(void);
void cdecl IStopComPort(void);

void cdecl ISendComBuffer();
void cdecl IReadComBuffer();

WORD cdecl GetRComStatus(void);
WORD cdecl GetWComStatus(void);
#endif