/*
  Com-⮬...
*/
#include "qgames.h"
#include "qgcmport.h"
#include <dos.h>

BOOL libSetPortAddr(BYTE bComPort)
{
	asm mov al,bComPort;
	asm xor ah,ah;
	asm mov si,0x40;
	asm mov es,si;
	asm mov di,ax;
	asm mov si,di;
	asm shl si,1;
	asm shl di,1;
	asm mov ax,[es:si];
	asm mov word ptr libBaseAddr[di],ax;

	if(!libBaseAddr[_DI])
		return FALSE;


	return TRUE;
}

void libSetSpeed(BYTE bComPort,WORD Speed)
{
	asm mov al,bComPort;
	asm xor ah,ah;
	asm mov si,ax;
	asm shl si,1;
	asm mov bx,word ptr libBaseAddr[si];
	asm mov dx,bx;
	asm add dx,3;
	asm in al,dx;
	asm or al,0x80;
	asm out dx,al;
	asm mov dx,bx;
	asm mov ax,Speed;
	asm out dx,al;
	asm mov al,ah;
	asm inc dx;
	asm out dx,al;
}

void libSetCTStat(BYTE bComPort,BYTE bMask)
{
	asm mov al,bComPort;
	asm xor ah,ah;
	asm mov si,ax;
	asm shl si,1;
	asm mov dx,word ptr libBaseAddr[si];
	asm add dx,3;
	asm mov al,bMask;
	asm and al,0x7F;
	asm out dx,al;
}

void libSetIMask(BYTE bComPort,BYTE bMask)
{
	asm mov al,bComPort;
	asm xor ah,ah;
	asm mov si,ax;
	asm shl si,1;
	asm mov dx,word ptr libBaseAddr[si];
	asm inc dx;
	asm mov al,bMask;
	asm out dx,al;
}

WORD libGetSpeed(BYTE bComPort)
{
	WORD RetVal;

	asm mov al,bComPort;
	asm xor ah,ah
	asm mov si,ax;
	asm shl si,1;
	asm mov bx,word ptr libBaseAddr[si];
	asm mov dx,bx;
	asm add dx,3;
	asm in al,dx;
	asm or al,0x80;
	asm out dx,al;
	asm mov dx,bx;
	asm in al,dx;
	asm mov ah,al;
	asm inc dx;
	asm in al,dx;
	asm mov RetVal,ax;

	return RetVal;
}

BYTE libGetCTStat(BYTE bComPort)
{
	BYTE RetVal;

	asm mov al,bComPort;
	asm xor ah,ah;
	asm mov si,ax;
	asm shl si,1;
	asm mov dx,word ptr libBaseAddr[si];
	asm add dx,3;
	asm in al,dx;
	asm mov RetVal,al;

	return RetVal;
}

BYTE libGetMDStat(BYTE bComPort)
{
	BYTE RetVal;

	asm mov al,bComPort;
	asm xor ah,ah;
	asm mov si,ax;
	asm shl si,1;
	asm mov dx,word ptr libBaseAddr[si];
	asm add dx,6;
	asm in al,dx;
	asm mov RetVal,al;

	return RetVal;

}

BYTE libGetRWStat(BYTE bComPort)
{
	BYTE RetVal;

	asm mov al,bComPort;
	asm xor ah,ah;
	asm mov si,ax;
	asm shl si,1;
	asm mov dx,word ptr libBaseAddr[si];
	asm add dx,5;
	asm in al,dx;
	asm mov RetVal,al;

	return RetVal;
}

BYTE libGetIMask(BYTE bComPort)
{
	BYTE RetVal;

	asm mov al,bComPort;
	asm xor ah,ah;
	asm mov si,ax;
	asm shl si,1;
	asm mov dx,word ptr libBaseAddr[si];
	asm inc dx;
	asm in al,dx;
	asm mov RetVal,al;

	return RetVal;
}

BYTE libGetIStat(BYTE bComPort)
{
	BYTE RetVal;

	asm mov al,bComPort;
	asm xor ah,ah;
	asm mov si,ax;
	asm shl si,1;
	asm mov dx,word ptr libBaseAddr[si];
	asm add dx,2;
	asm in al,dx;
	asm mov RetVal,al;

	return RetVal;
}

WORD GetRComStatus(void)
{
	return libInCurPoint;
}

WORD GetWComStatus(void)
{
	return libOutCurPoint;
}

BYTE libReadByte(BYTE bComPort)
{
	BYTE RetVal;

	asm mov al,bComPort;
	asm xor ah,ah;
	asm mov si,ax;
	asm shl si,1;
	asm mov dx,word ptr libBaseAddr[si];
	asm in al,dx;
	asm mov RetVal,al;

	return RetVal;
}

void libWriteByte(BYTE bComPort,BYTE bSymb)
{
	asm mov al,bComPort;
	asm xor ah,ah;
	asm mov si,ax;
	asm shl si,1;
	asm mov dx,word ptr libBaseAddr[si];
	asm mov al,bSymb;
	asm out dx,al;
}



BOOL InitStdCom(BYTE bComPort,WORD wSpeed,BYTE bStat)
{
	if(bComPort > 3)
		return FALSE;


	if(libInit[bComPort])
		UninitStdCom(bComPort);

	libSpeed[bComPort] = libGetSpeed(bComPort);
	libStat[bComPort]  = libGetCTStat(bComPort);
	libIMask[bComPort] = libGetIMask(bComPort);
	libSetSpeed(bComPort,wSpeed);
	libSetCTStat(bComPort,bStat);
	libSetIMask(bComPort,FALSE);

	libInit[bComPort] = TRUE;
	return TRUE;
}

void UninitStdCom(BYTE bComPort)
{
	if(bComPort > 3)
		return;

	if(!libInit[bComPort])
		return;

	libSetSpeed(bComPort,libSpeed[bComPort]);
	libSetCTStat(bComPort,libStat[bComPort]);
	libSetIMask(bComPort,libIMask[bComPort]);

	libInit[bComPort] = FALSE;
}


BYTE OutStdCom(BYTE bComPort,PBYTE pbSymb)
{
	BYTE bStat;

	if(bComPort > 3)
		return ECP_ERRORWR;

	bStat = libGetRWStat(bComPort);

	if(bStat & 0x8E)
		return ECP_ERRORWR;


	if(bStat & 1)
		return ECP_READ;

	if(!(bStat & 0x20))
		return ECP_WAIT;

	libWriteByte(bComPort,*pbSymb);
	return ECP_OK;
}

BYTE InStdCom(BYTE bComPort,PBYTE pbSymb)
{
	BYTE bStat;
	if(bComPort > 3)
		return ECP_ERRORWR;

	bStat = libGetRWStat(bComPort);


	if(bStat & 0x8E)
		return ECP_ERRORWR;


	if(!(bStat & 1))
		return ECP_WAIT;

	(*pbSymb) = libReadByte(bComPort);

	return ECP_OK;
}

BYTE GetStdComRWStat(BYTE bComPort)
{
	if(bComPort > 3)
		return FALSE;

	return libGetRWStat(bComPort);
}

BYTE GetStdComCTStat(BYTE bComPort)
{
	if(bComPort > 3)
		return FALSE;

	return libGetCTStat(bComPort);
}

BYTE GetStdComMDStat(BYTE bComPort)
{
	if(bComPort > 3)
		return FALSE;

	return libGetMDStat(bComPort);
}



void interrupt libPortInterrupt(void)
{
	BYTE bReg = 0;
	BYTE bStat;

	while(1)
	{

		bReg = libGetIStat(libIntPort);

		if(bReg & 1)
			break;

		switch(bReg & 6)
		{
		case 0:
			libMessFunc(FCM_MODEMLINE);
			break;
		case 2:
			if(libOutFlag)
			{
				libWriteByte(libIntPort,libOutBuff[libOutCurPoint]);
				libOutCurPoint++;
				if(libOutBuffLen <= libOutCurPoint)
				{
					libOutFlag = FALSE;
					libMessFunc(FCM_DATASENDED);
					break;
				}
			}
			else
			{
				libSetIMask(libIntPort,0xD);
				BOUT(0x20,0x20);
				return;
			}
		case 4:
			if(!libInFlag)
				libMessFunc(FCM_NOBUFFER);
			else
			{
				libInBuff[libInCurPoint] = libReadByte(libIntPort);
				libInCurPoint++;

				if(libInBuffLen <= libInCurPoint)
				{
					libInFlag = FALSE;
					libMessFunc(FCM_DATAREADED);
				}
			}
			break;
		case 6:
			libMessFunc(FCM_ERRORLINE);
		default:
			BOUT(0x20,0x20);
			return;
		}
	if(libStopFlag)
		break;
	}
	BOUT(0x20,0x20);
}


void QGamesComPort(BYTE bComPort,WORD wSpeed,BYTE bStat)
{

	if(bComPort > 1)
		return;

	if(!libSetPortAddr(bComPort))
		return FALSE;

	if(libIntPort != 0xFF)
		return;

	if(libInit[bComPort])
		UninitStdCom(bComPort);

	libIntPort = bComPort;
	libStopFlag = FALSE;

	asm mov al,bComPort;
	asm xor ah,ah;
	asm mov si,ax;
	asm shl si,1;
	asm mov dx,word ptr libBaseAddr[si];
	asm add dx,4;
	asm in al,dx;
	asm or al,0xB;
	asm out dx,al;

	switch(bComPort)
	{
	case COM1:
		libFunCmOldInter = getvect(0xC);
		setvect(0xC,libPortInterrupt);


		asm mov dx,0x21;
		asm in al,dx;
		asm and al,0xEF;
		asm out dx,al;

		break;
	case COM2:
		libFunCmOldInter = getvect(0xB);
		setvect(0xB,libPortInterrupt);

		asm mov dx,0x21;
		asm in al,dx;
		asm and al,0xF7;
		asm out dx,al;
		break;
	default:
		return;
	}


	libSpeed[bComPort] = libGetSpeed(bComPort);
	libStat[bComPort]  = libGetCTStat(bComPort);
	libIMask[bComPort] = libGetIMask(bComPort);
	libSetSpeed(bComPort,wSpeed);
	libSetCTStat(bComPort,bStat);
	libSetIMask(bComPort,0xD);

	libInit[bComPort] = TRUE;
}

void DosComPort(void)
{
	UninitStdCom(libIntPort);
	libSetIMask(libIntPort,0);
	switch(libIntPort)
	{
	case COM1:
		setvect(0xC,libFunCmOldInter);
		break;
	case COM2:
		setvect(0xB,libFunCmOldInter);
		break;
	default:
		return;
	}
	libIntPort = 0xFF;
}

void ISetComWBuff(PSTR pBuffer,WORD wLen)
{
	libOutBuff = pBuffer;
	libOutBuffLen = wLen;
}

void ISetComRBuff(PSTR pBuffer,WORD wLen)
{
	libInBuff = pBuffer;
	libInBuffLen = wLen;
	libInCurPoint = 0;
	libInFlag = TRUE;
}

void ISendComBuffer(void)
{
	libOutCurPoint = 0;
	libSetIMask(libIntPort,0xF);
	libOutFlag = TRUE;
}

void IReadComBuffer(void)
{
	libInCurPoint = 0;
	libInFlag = TRUE;
}

void IStopComPort(void)
{
	libSetIMask(libIntPort,0);
	libStopFlag = TRUE;
}

void SetComFunc(FNCOM fnCom)
{
	libMessFunc = fnCom;
}

void ContinueComPort(void)
{
	libSetIMask(libIntPort,0xD);
	libStopFlag = FALSE;
}

void IDefaultComFunc(BYTE Message)
{
	BYTE Reg;
	switch(Message)
	{
	case FCM_MODEMLINE:
		GetStdComMDStat(libIntPort);
		break;
	case FCM_ERRORLINE:
		GetStdComRWStat(libIntPort);
		break;
	case FCM_DATASENDED:
		ContinueComPort();
		break;
	case FCM_DATAREADED:
		IReadComBuffer();
		break;
	case FCM_NOBUFFER:
		IStopComPort();
		break;
	}
}