/*
প 䠩 .BMP
*/
#include "qgff.h"


BYTE LoadBMPPal(PSTR pFileName,PRGBPAL pRgbPal)
{
	BITMAPFILEHEADER FHeader;
	BITMAPINFOHEADER IHeader;
	RGBQUAD RgbBitmap;
	PRGBPAL pCurRgb = pRgbPal;
	int Counter;
	int Handle,ErrCode;
	Handle  = open(pFileName,O_BINARY);
	if(Handle == -1)
		return QG_NOFILE;

	ErrCode = read(Handle,&FHeader,sizeof(BITMAPFILEHEADER));
	if(ErrCode == -1)
	{
		close(Handle);
		return QG_ERFORMAT;
	}
	if(FHeader.bfType != 'BM')
	{
		close(Handle);
		return QG_ERFORMAT;
	}

	ErrCode = read(Handle,&IHeader,sizeof(BITMAPINFOHEADER));
	if(ErrCode == -1)
	{
		close(Handle);
		return QG_ERFORMAT;
	}
	if(IHeader.biCompression != 0 ||
		IHeader.biBitCount != 8)
	{
		close(Handle);
		return QG_NOSUPPORT;
	}

	for(Counter = 0;Counter < 256;Counter++)
	{
		ErrCode = read(Handle,&RgbBitmap,sizeof(RGBQUAD));
		if(ErrCode == -1)
		{
			close(Handle);
			return QG_ERFORMAT;
		}
		pCurRgb[Counter].Red   = RgbBitmap.rgbRed;
		pCurRgb[Counter].Green = RgbBitmap.rgbGreen;
		pCurRgb[Counter].Blue  = RgbBitmap.rgbBlue;
	}
	close(Handle);
	return QG_OK;
}

BYTE LoadBMPInfo(PSTR pFileName,PBITMAP pBitmap)
{
	BITMAPFILEHEADER FHeader;
	BITMAPINFOHEADER IHeader;
	int Handle,ErrCode;
	Handle  = open(pFileName,O_BINARY);
	if(Handle == -1)
		return QG_NOFILE;

	ErrCode = read(Handle,&FHeader,sizeof(BITMAPFILEHEADER));
	if(ErrCode == -1)
	{
		close(Handle);
		return QG_ERFORMAT;
	}
	if(FHeader.bfType != 'BM')
	{
		close(Handle);
		return QG_ERFORMAT;
	}

	ErrCode = read(Handle,&IHeader,sizeof(BITMAPINFOHEADER));
	if(ErrCode == -1)
	{
		close(Handle);
		return QG_ERFORMAT;
	}
	if(IHeader.biCompression != 0 ||
		IHeader.biBitCount != 8)
	{
		close(Handle);
		return QG_NOSUPPORT;
	}

	pBitmap->Width = IHeader.biWidth;
	pBitmap->Height = IHeader.biHeight;
	close(Handle);
	return QG_OK;
}

BYTE LoadBMPData(PSTR pFileName,PBITMAP pBitmap)
{
	BITMAPFILEHEADER FHeader;
	BITMAPINFOHEADER IHeader;
	static BYTE MaxLine[1000];
	PSTR CurBuffer;
	int Handle,ErrCode;
	int Counter;

	Handle  = open(pFileName,O_BINARY);
	if(Handle == -1)
		return QG_NOFILE;

	ErrCode = read(Handle,&FHeader,sizeof(BITMAPFILEHEADER));
	if(ErrCode == -1)
	{
		close(Handle);
		return QG_ERFORMAT;
	}
	if(FHeader.bfType != 'BM')
	{
		close(Handle);
		return QG_ERFORMAT;
	}

	ErrCode = read(Handle,&IHeader,sizeof(BITMAPINFOHEADER));
	if(ErrCode == -1)
	{
		close(Handle);
		return QG_ERFORMAT;
	}
	if(IHeader.biCompression != 0 ||
		IHeader.biBitCount != 8)
	{
		close(Handle);
		return QG_NOSUPPORT;
	}
	lseek(Handle,FHeader.bfOffBits,SEEK_SET);
	if(IHeader.biSize >= 0xFFFF ||
		IHeader.biWidth >= 1000)
	{
		close(Handle);
		return QG_NOSUPPORT;
	}

	CurBuffer = pBitmap->Buffer;
	CurBuffer += IHeader.biWidth * (IHeader.biHeight - 1);

	for(Counter = 0;Counter < IHeader.biHeight;Counter++)
	{
		if(IHeader.biWidth % 4 )
			ErrCode = read(Handle,MaxLine,IHeader.biWidth +
						  4 - (IHeader.biWidth % 4));
		else
			ErrCode = read(Handle,MaxLine,IHeader.biWidth);

		if(ErrCode == -1)
			return QG_ERFORMAT;

		memcpy(CurBuffer,MaxLine,IHeader.biWidth);
		CurBuffer -= IHeader.biWidth;

	}
	close(Handle);
	return QG_OK;
}