/*
ன⢠ ...
*/

#include "qgames.h"
#include "qginput.h"

/*...*/


void QGamesKeyboard()
{
	if(libKeyboard)
		return;

	libFunKbOldInter = getvect(9);
	setvect(9,libKeyboardInterrupt);

	libKeyboard = TRUE;
}

void DosKeyboard()
{
	if(!libKeyboard)
		return;
	setvect(9,libFunKbOldInter);
	libKeyboard = FALSE;
}

void interrupt libKeyboardInterrupt(void)
{
	char KeyCode;

	BIN(0x60,KeyCode);
	libBufferKeyboard[libPrevKey++ & 0xf] = KeyCode;
	BOUT(0x20,0x20);
}

BYTE GetKey(PBYTE pByte)
{
	BOOL KeyVal;
	if(libCurKey == libPrevKey)
		return UNKNOWN_KEY;

	*pByte  = libTabChar[libBufferKeyboard[libCurKey & 0xf] & 0x7f];
	KeyVal = (BOOL)((libBufferKeyboard[libCurKey & 0xf] & 0x80) != 0);
	libCurKey++;

	if(!KeyVal)
		return PRESS_KEY;

	return RELEASE_KEY;
}

void GetMapKey(PSTKEYMAP pstKMap)
{
	BOOL KeyFlag;
	if(libCurKey == libPrevKey)
		return;

	while(libCurKey != libPrevKey)
	{
		KeyFlag = ((libBufferKeyboard[libCurKey & 0xf] & 0x80) == 0);

		switch(libTabChar[libBufferKeyboard[libCurKey & 0xf] & 0x7f])
		{
		case UP:
			pstKMap->Up = KeyFlag;
			break;

		case LEFT:
			pstKMap->Left = KeyFlag;
			break;

		case RIGHT:
			pstKMap->Right = KeyFlag;
			break;

		case DOWN:
			pstKMap->Down = KeyFlag;
			break;

		case ENTER:
			pstKMap->Enter = KeyFlag;
			break;

		case SPACE:
			pstKMap->Space = KeyFlag;
			break;

		case TAB:
			pstKMap->Tab = KeyFlag;
			break;

		case CTRL:
			pstKMap->Ctrl = KeyFlag;
			break;

		case SHIFT:
			pstKMap->Shift = KeyFlag;
			break;

		case ALT:
			pstKMap->Alt = KeyFlag;
			break;

		case F1:
			pstKMap->_F1 = KeyFlag;
			break;

		case ESC:
			pstKMap->Esc = KeyFlag;
			break;

		default:
			break;
		}

		libCurKey++;
	}

}

/*...*/
BOOL GetMouseInit()
{
	asm mov ax,0;
	asm int 0x33;
	if(!_AX)
		return FALSE;
	return TRUE;
}

void MouseCursorOn()
{
	asm mov ax,1;
	asm int 0x33;
}

void MouseCursorOff()
{
	asm mov ax,2;
	asm int 0x33;
}

void SetMouseCursor(WORD HotX,WORD HotY,PBYTE pBit)
{
	if(HotX > 16 || HotY > 16)
		return;

	asm mov ax,9;
	asm mov bx,HotX;
	asm mov cx,HotY;
	asm les dx,pBit;
	asm int 0x33;
}

void GetMouseMap(PSTMOUSEMAP pstMMap)
{
	WORD X,Y,Keys;
	asm mov ax,3;
	asm int 0x33;
	asm mov Keys,bx;
	asm mov X,cx;
	asm mov Y,dx;

	if(libDisplayMode == VGA_MODE)
		X = X >> 1;
	else if(libDisplayMode == TEXT_MODE)
	{
		X = X >> 3;
   	Y = Y >> 3;
	}
	pstMMap->PosY = Y;
	pstMMap->PosX = X;
	pstMMap->RightKey = Keys & 2;
	pstMMap->LeftKey  = Keys & 1;

}

void GetMouseMoving(int* MoveX,int* MoveY)
{
	asm mov ax,0xb;
	asm int 0x33;
	asm les di,MoveX;
	asm mov [es:di],cx;
	asm les di,MoveY;
	asm mov [es:di],dx;
}
